//
// This is a part of e-sushi module sourcecode
// for Litestep, a replacement shell.
// Copyright (C) 2002 Mike Edward Moras / e-sushi
//
// This program is free software;
// you can redistribute it and/or modify it under
// the terms of the GNU General Public License
// as published by the Free Software Foundation;
// either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it
// will be useful, but WITHOUT ANY WARRANTY; without
// even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the
// GNU General Public License along with this program;
// if not, write to: Free Software Foundation, Inc.
//                   59 Temple Place - Suite 330
//                   Boston
//                   MA  02111-1307, USA.
//
/*
11JUN02 - e-sushi (Mike Edward Moras)
After losing all code of my previous module "themez.dll"
I had to rerwrite from scratch. This module does not
support RevID (yet) but that's not such a problem...
the rest is back again from the lost horizon and...
I ADDED SOMETHING TO PREVIOUS KNOWN FUNCTIONALITY:
- always generates a sorted list using qsort
(some systems didn't sort right using the previous
version of this module) Now that's a treat, isn't it?

The 3 bangs pushing this module are:
!THEMESETUP
!THEMEGET
!THEMESET
oh yeah, and a !THEMEABOUT <g>
*/

#define WIN32_LEAN_AND_MEAN
#include "../lsapi/lsapi.h"
#include "io.h"


void bangABOUT(HWND caller, LPCSTR args);
void bangSET(HWND caller, LPCSTR args);
void bangSETUP(HWND caller, LPCSTR args);
void bangGET(HWND caller, LPCSTR args);

void QuickSort (char** szArray, int nLower, int nUpper);
int Partition (char** szArray, int nLower, int nUpper);

extern "C" {
    __declspec( dllexport ) int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath);
    __declspec( dllexport ) void quitModule(HINSTANCE dllInst);
}

int initModuleEx(HWND parentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
    int code = 0;

    AddBangCommand("!THEMEABOUT", bangABOUT);
    AddBangCommand("!THEMESET", bangSET);
    AddBangCommand("!THEMESETUP", bangSETUP);
	AddBangCommand("!THEMEGET", bangGET);
    return code;
}

void quitModule(HINSTANCE dllInst)
{
    RemoveBangCommand("!THEMEABOUT");
    RemoveBangCommand("!THEMESET");
    RemoveBangCommand("!THEMESETUP");
	RemoveBangCommand("!THEMEGET");
}


//define those bangs...

void bangABOUT(HWND caller, LPCSTR args)
{
 MessageBox(
  caller,
  "Themez3.dll\n\nA litestep popup theme switcher module\nwith auto-sorting functionality!\n\ncreated by Mike Edward Moras (e-sushi)\nhttp://e-sushi.cjb.net",
  "About Themez3.dll",
  MB_OK|MB_SYSTEMMODAL
);


 

}

void bangSET(HWND caller, LPCSTR args)
{
  char szthemeactPath[MAX_PATH];
  LSGetLitestepPath(szthemeactPath, MAX_PATH);
  strcat(szthemeactPath, "\\activetheme.rc");
  FILE *stream;
  stream = fopen( szthemeactPath, "w" );
  fprintf(stream,"include \"$litestepdir$themes\\%s\\step.rc\"\n",args);
  
  fprintf(stream,"DIRTHEME %s\n",args);
  fprintf(stream,"DIRTHEMES %s\n",args);
  fprintf(stream,"THEMEDIR %s\n",args);
  fprintf(stream,"THEMESDIR %s\n",args);

  fclose( stream );
  LSExecuteEx(GetLitestepWnd(), NULL, "!Recycle", NULL, NULL, 0);
}

void bangSETUP(HWND caller, LPCSTR args)
{
  char szScanPath[MAX_PATH];
  char szthemePath[MAX_PATH];
  LSGetLitestepPath(szthemePath, MAX_PATH);
  LSGetLitestepPath(szScanPath, MAX_PATH);
  strcat(szScanPath, "\\themes\\*.*");
  strcat(szthemePath, "\\themez.rc");
  FILE *stream;
  stream = fopen( szthemePath, "w" );
  struct _finddata_t c_file;
  long hFile;
  if((hFile = _findfirst(szScanPath, &c_file)) != -1L)
  _findnext(hFile, &c_file);
  while(_findnext(hFile, &c_file) == 0){
  if((c_file.attrib & _A_SUBDIR )){
  fprintf(stream,"*popup \"%s\" !themeset %s\n", c_file.name,c_file.name);
  }
  }
  fclose( stream );
  char szScanokPath[MAX_PATH];
  LSGetLitestepPath(szScanokPath, MAX_PATH);
  strcat(szScanokPath, "\\themes\\*.*");
  char szthemeactPath[MAX_PATH];
  LSGetLitestepPath(szthemeactPath, MAX_PATH);
  strcat(szthemeactPath, "\\activetheme.rc");
  FILE *streamb;
  streamb = fopen( szthemeactPath, "w" );
  struct _finddata_t c_fileb;
  long hFileb;
  if((hFileb = _findfirst(szScanokPath, &c_fileb)) != -1L)
  _findnext(hFileb, &c_fileb);
  _findnext(hFileb, &c_fileb);
    if((c_fileb.attrib & _A_SUBDIR )){
  fprintf(streamb,"include \"$litestepdir$themes\\%s\\step.rc\"\n",c_fileb.name);
//DIRTHEME and THEMEDIR and THEMESDIRand DIRTHEMES
  fprintf(streamb,"\nDIRTHEME %s\n",args);
  fprintf(streamb,"\nDIRTHEMES %s\n",args);
  fprintf(streamb,"\nTHEMEDIR %s\n",args);
  fprintf(streamb,"\nTHEMESDIR %s\n",args);
  }
  fclose( streamb );

	char szSrcFile[MAX_PATH], szDestFile[MAX_PATH];
	LSGetLitestepPath(szSrcFile, MAX_PATH);
	LSGetLitestepPath(szDestFile, MAX_PATH);
	strcat(szSrcFile, "\\themez.rc");
	strcat(szDestFile, "\\theme.tmp");
	// Read contents of source file
	const int nGrow = 8;
	int nAlloc = nGrow, nSize = 0;
	char** szContents = new char* [nAlloc];
	char szSrcLine [1024];
	FILE* pStream = fopen (szSrcFile, "rt");
	while (fgets (szSrcLine, 1024, pStream))
	{
		// Trim newline character
		char* pszCheck = szSrcLine;
		while (*pszCheck != '\0')
		{
			if (*pszCheck == '\n' && *(pszCheck + 1) == '\0')
				*pszCheck = '\0';
			pszCheck++;
		}
		// Append to array
		szContents[nSize] = new char [strlen (szSrcLine) + 1];
		//convert this sucker to to lowercase to avoid Upper/Lower sorting weirdness...
		strcpy (szContents[nSize], _strlwr(szSrcLine));
		nSize = nSize + 1;
		if (nSize % nGrow == 0)
		{
			char** szPrev = szContents;
			nAlloc += nGrow;
			szContents = new char* [nAlloc];
			memcpy (szContents, szPrev, nSize * sizeof(char*));
			delete szPrev;
		}
	}
	fclose (pStream);
	// Pass to QuickSort function
	QuickSort (szContents, 0, nSize - 1);
	// Write sorted lines
	pStream = fopen (szDestFile, "wt");
	for (int nIndex = 0; nIndex < nSize; nIndex++)
	{
		fprintf (pStream, "%s\n", szContents[nIndex]);
	}
	fclose (pStream);


	for (nIndex = 0; nIndex < nSize; nIndex++)
	{
		delete szContents[nIndex];
	}
	delete szContents;
	szContents = NULL;
//copy tmp 2 rc and delete tmp file
DeleteFile(szSrcFile);
CopyFile(szDestFile,szSrcFile,NULL);
DeleteFile(szDestFile);

  LSExecuteEx(GetLitestepWnd(), NULL, "!Recycle", NULL, NULL, 0);
}


void bangGET(HWND caller, LPCSTR args)
{
	  char szScanPath[MAX_PATH];
  LSGetLitestepPath(szScanPath, MAX_PATH);
  strcat(szScanPath, "\\themes\\*.*");
  char szthemePath[MAX_PATH];
  LSGetLitestepPath(szthemePath, MAX_PATH);
  strcat(szthemePath, "\\themez.rc");
  FILE *stream;
  stream = fopen( szthemePath, "w" );
  struct _finddata_t c_file;
  long hFile;
  if((hFile = _findfirst(szScanPath, &c_file)) != -1L)
  _findnext(hFile, &c_file);
  while(_findnext(hFile, &c_file) == 0){
  if((c_file.attrib & _A_SUBDIR )){
  fprintf(stream,"*popup \"%s\" !themeset %s\n", c_file.name,c_file.name);
  }
  }
  fclose( stream );
  
	char szSrcFile[MAX_PATH], szDestFile[MAX_PATH];
	LSGetLitestepPath(szSrcFile, MAX_PATH);
	LSGetLitestepPath(szDestFile, MAX_PATH);
	strcat(szSrcFile, "\\themez.rc");
	strcat(szDestFile, "\\theme.tmp");
	// Read contents of source file
	const int nGrow = 8;
	int nAlloc = nGrow, nSize = 0;
	char** szContents = new char* [nAlloc];
	char szSrcLine [1024];
	FILE* pStream = fopen (szSrcFile, "rt");
	while (fgets (szSrcLine, 1024, pStream))
	{
		// Trim newline character
		char* pszCheck = szSrcLine;
		while (*pszCheck != '\0')
		{
			if (*pszCheck == '\n' && *(pszCheck + 1) == '\0')
				*pszCheck = '\0';
			pszCheck++;
		}
		// Append to array
		szContents[nSize] = new char [strlen (szSrcLine) + 1];
		//convert this sucker to to lowercase to avoid Upper/Lower sorting weirdness...
		strcpy (szContents[nSize], _strlwr(szSrcLine));
		nSize = nSize + 1;
		if (nSize % nGrow == 0)
		{
			char** szPrev = szContents;
			nAlloc += nGrow;
			szContents = new char* [nAlloc];
			memcpy (szContents, szPrev, nSize * sizeof(char*));
			delete szPrev;
		}
	}
	fclose (pStream);
	// Pass to QuickSort function
	QuickSort (szContents, 0, nSize - 1);
	// Write sorted lines
	pStream = fopen (szDestFile, "wt");
	for (int nIndex = 0; nIndex < nSize; nIndex++)
	{
		fprintf (pStream, "%s\n", szContents[nIndex]);
	}
	fclose (pStream);


	for (nIndex = 0; nIndex < nSize; nIndex++)
	{
		delete szContents[nIndex];
	}
	delete szContents;
	szContents = NULL;
//copy tmp 2 rc and delete tmp file
DeleteFile(szSrcFile);
CopyFile(szDestFile,szSrcFile,NULL);
DeleteFile(szDestFile);

LSExecuteEx(GetLitestepWnd(), NULL, "!Recycle", NULL, NULL, 0);
}

// QuickSort implementation
void QuickSort (char** szArray, int nLower, int nUpper)
{

	if (nLower < nUpper)
	{

		int nSplit = Partition (szArray, nLower, nUpper);
		QuickSort (szArray, nLower, nSplit - 1);
		QuickSort (szArray, nSplit + 1, nUpper);
	}
}

// QuickSort partition implementation
int Partition (char** szArray, int nLower, int nUpper)
{
	int nLeft = nLower + 1;
	char* szPivot = szArray[nLower];
	int nRight = nUpper;

	char* szSwap;
	while (nLeft <= nRight)
	{
		while (nLeft <= nRight && strcmp (szArray[nLeft], szPivot) <= 0)
			nLeft = nLeft + 1;
		while (nLeft <= nRight && strcmp (szArray[nRight], szPivot) > 0)
			nRight = nRight - 1;
	
		if (nLeft < nRight)
		{
			szSwap = szArray[nLeft];
			szArray[nLeft] = szArray[nRight];
			szArray[nRight] = szSwap;
			nLeft = nLeft + 1;
			nRight = nRight - 1;
		}
	}
	
	szSwap = szArray[nLower];
	szArray[nLower] = szArray[nRight];
	szArray[nRight] = szSwap;
	return nRight;
}
